import Vue from "vue";
import Vuex from "vuex";
import VuexPersistedState from "vuex-persistedstate";

Vue.use(Vuex);
const vuexLocal = VuexPersistedState({
  key: "imageboard",
  paths: ["stateUser"],
});

export default new Vuex.Store({
  state: {
    stateImageSnowflakes: [],
    stateUser: {
      id: null,
      privileged: null,
      username: null,
      secret: null,
    },
  },
  mutations: {
    setStateImageSnowflakes(state, array) {
      state.stateImageSnowflakes = array;
    },
    addStateImageSnowflake(state, hash) {
      state.stateImageSnowflakes.push(hash);
    },
    saveStateUser(state, payload) {
      state.stateUser.id = payload.id;
      state.stateUser.privileged = payload.privileged;
      state.stateUser.username = payload.username;
      state.stateUser.secret = payload.secret;
    },
  },
  actions: {
    setStateImageSnowflakes(context, payload) {
      context.commit("setStateImageSnowflakes", payload);
    },
    addStateImageSnowflake(context, payload) {
      context.commit("addStateImageSnowflake", payload);
    },
    saveStateUser(context, payload) {
      context.commit("saveStateUser", payload);
    },
  },
  modules: {},
  plugins: [vuexLocal],
});
